#include "grbc/ext.h"
#include "grbc/helpers.h"
#include "grbc/spec.h"
#include "grbc/state.h"

void grbc_register_ext(const Extension &ext) {
  GState::get().extensions.push_back(ext);

  log_msg(("registered extension: " + ext.name).c_str());
  printf(">  init pointer: %p\n", ext.hook_init);
}

void grbc_ext(const std::string &extension_id) {
  for (auto &ext : GState::get().extensions) {
    if (ext.name != extension_id)
      continue;

    log_msg(("loading extension: " + extension_id).c_str());

    ext.hook_init(GState::get().lua);

    return;
  }

  grbc_exception("Failed to find extension with name: " + extension_id);
}