#include "grbc/generator.h"
#include "grbc/helpers.h"
#include "grbc/spec.h"
#include "grbc/state.h"
#include <fstream>

void grbc_build(const std::string &generator_id) {
  GState::get().global_linker_flags += "-L" + grbc_get_config().build_dir + " -Wl,-rpath," + grbc_get_config().build_dir + ":. ";

  log_msg(("finding generator with name: " + generator_id).c_str());

  for (auto &gen : GState::get().generators) {
    if (gen.name == generator_id) {
      GeneratorResult result = gen.func();

      std::ofstream ofs(result.file_name);
      ofs << result.content;

      return;
    }
  }

  grbc_exception("Could not find valid generator!");
}